public Player_Death(Handle:event, const String:name[], bool:dontBroadcast) {
    new target0 = GetClientOfUserId(GetEventInt(event, "attacker"));
    new target1 = GetClientOfUserId(GetEventInt(event, "userid"));
    new target2 = GetClientOfUserId(GetEventInt(event, "assister"));
    new g_damagebits = GetEventInt(event, "damagebits");
    TempInputCrit = 0;
    
    if (g_damagebits & DF_CRITS) {
        TempInputCrit = 1;
        new attackerCond = g_ClientConditions[target0];
        new victimCond = g_ClientConditions[target1];
        if ((attackerCond & DF_CRITS_BUFFBANNER) || (victimCond & DF_CRITS_JARATE)) TempInputCrit = 2;
    }
    
    if (GetConVarInt(cvar_debug) == 1) PrintToChatAll("%d (%N) killed %d (%N)", target0, target0, target1, target1);
    
    if (IsValidClient(target0) && IsValidClient(target1)) CallAchievementEvent("kill",target0, target1, target2, 0);
    ExpireBlocks(target1, 1);
    ExpireBlocks(target0, 2);
}

public Action:Player_Hurt(victim, &attacker, &inflictor, &Float:damage, &damagetype) { 
    CallAchievementEvent("hurt",attacker, victim, 0, RoundFloat(damage));
    
    ExpireBlocks(victim, 3);
    return Plugin_Continue;
}

public Player_Hurt_Native(Handle:event, const String:name[], bool:dontBroadcast) {
    new target0 = GetClientOfUserId(GetEventInt(event, "attacker"));
    new target1 = GetClientOfUserId(GetEventInt(event, "userid"));

    CallAchievementEvent("hurt",target0, target1, 0, 0);
    ExpireBlocks(target1, 3);
}

public Action:Player_Chat(client, iArgs) {
    if (!(IsValidClient(client))) return Plugin_Continue;
    if (iArgs < 1) return Plugin_Continue;
    new String:text[128];
    GetCmdArg(1, text, sizeof(text));
    
    Format(TempInputString, sizeof(TempInputString), text);
    
    CallAchievementEvent("chat",client, 0, 0, 0);
    ExpireBlocks(client, 4);
    return Plugin_Continue;
}

public Player_Spawn(Handle:event, const String:name[], bool:dontBroadcast) {
    new target0 = GetClientOfUserId(GetEventInt(event, "userid"));

    CallAchievementEvent("spawn",target0, 0, 0, 0);
    ExpireBlocks(target0, 5);
}

public Break_Breakable(Handle:event, const String:name[], bool:dontBroadcast) {
    new target0 = GetClientOfUserId(GetEventInt(event, "userid"));

    CallAchievementEvent("break_breakable",target0, 0, 0, 0);
    ExpireBlocks(target0, 6);
}