stock bool:IsValidClient(iClient) {
    if (iClient <= 0) return false;
    if (iClient > MaxClients) return false;
    if (!IsClientConnected(iClient)) return false;
    return IsClientInGame(iClient);
}

stock SayText2(author_index , const String:message[] ) {
    new Handle:buffer = StartMessageAll("SayText2");
    if (buffer != INVALID_HANDLE) {
        BfWriteByte(buffer, author_index);
        BfWriteByte(buffer, true);
        BfWriteString(buffer, message);
        EndMessage();
    }
}

stock AchievementEffect(argClient) {
    new Float:strflVec[3];
    GetClientEyePosition(argClient, strflVec);
    
    EmitSoundToAll(ACHIEVEMENT_SOUND, argClient);
    
    new strIParticle = CreateEntityByName("info_particle_system");
    new String:strName[128];
    if (IsValidEdict(strIParticle)) {
        new Float:strflPos[3];
        GetEntPropVector(argClient, Prop_Send, "m_vecOrigin", strflPos);
        TeleportEntity(strIParticle, strflPos, NULL_VECTOR, NULL_VECTOR);
        
        Format(strName, sizeof(strName), "target%i", argClient);
        DispatchKeyValue(argClient, "targetname", strName);
        
        DispatchKeyValue(strIParticle, "targetname", "tf2particle");
        DispatchKeyValue(strIParticle, "parentname", strName);
        DispatchKeyValue(strIParticle, "effect_name", ACHIEVEMENT_PARTICLE);
        DispatchSpawn(strIParticle);
        SetVariantString(strName);
        AcceptEntityInput(strIParticle, "SetParent", strIParticle, strIParticle, 0);
        SetVariantString("head");
        AcceptEntityInput(strIParticle, "SetParentAttachment", strIParticle, strIParticle, 0);
        ActivateEntity(strIParticle);
        AcceptEntityInput(strIParticle, "start");
        
        CreateTimer(5.0, Timer_DeleteParticles, strIParticle);
    }
}

public Action:Timer_DeleteParticles(Handle:argTimer, any:argIParticle) {
    if (IsValidEntity(argIParticle)) {
        new String:strClassname[256];
        GetEdictClassname(argIParticle, strClassname, sizeof(strClassname));
        
        if (StrEqual(strClassname, "info_particle_system", false)) {
            RemoveEdict(argIParticle);
        }
    }
}

stock UpdateClientCondition(client) {
    if (IsValidClient(client) && IsPlayerAlive(client)) {
        if (g_Gamemode == 1) g_ClientConditions[client] = GetEntData(client, FindSendPropInfo("CTFPlayer", "m_nPlayerCond"));
        if (g_Gamemode == 2 && GetClientTeam(client) == 2) g_ClientConditions[client] = GetEntProp(client, Prop_Send, "m_survivorCharacter");
        if (g_Gamemode == 2 && GetClientTeam(client) == 3) g_ClientConditions[client] = GetEntProp(client, Prop_Send, "m_zombieClass");
    }
}