public Point_Capture(Handle:event, const String:name[], bool:noBroadcast) {
    decl String:cappers[MAXPLAYERS+1] = "";
    if (GetEventString(event,"cappers", cappers, MAXPLAYERS)>0) {
        new len = strlen(cappers);
        Req_Capture_Count = len;
        for(new i=0;i<len;i++) {
            new index = cappers{i};
            CallAchievementEvent("capture",index, 0, 0, len);
            ExpireBlocks(-1, 100);
        }
    }
}

public Deploy_Buff_Banner(Handle:event, const String:name[], bool:noBroadcast) {
    new target0 = GetEventInt(event, "buff_owner");
    CallAchievementEvent("buffbanner",target0, 0, 0, 0);
    ExpireBlocks(target0, 101);
}

public Player_Mvp(Handle:event, const String:name[], bool:noBroadcast) {
    new target0 = GetEventInt(event, "player");
    CallAchievementEvent("mvp",target0, 0, 0, 0);
    ExpireBlocks(target0, 102);
}

public Player_Sapped_Object(Handle:event, const String:name[], bool:noBroadcast) {
    new target0 = GetClientOfUserId(GetEventInt(event, "userid"));
    new target1 = GetClientOfUserId(GetEventInt(event, "ownerid"));
    CallAchievementEvent("player_sapped",target0, target1, 0, 0);
    ExpireBlocks(target0, 103);
    ExpireBlocks(target1, 104);
}

// Does not seem to work
public Player_HealedByMedic(Handle:event, const String:name[], bool:noBroadcast) {
    new target0 = GetEventInt(event, "medic");
    new target1 = GetHealtarget(target0);
    CallAchievementEvent("medic_heal",target0, target1, 0, 0);
    ExpireBlocks(target0, 105);
    ExpireBlocks(target1, 106);
}

public Player_Chargedeployed(Handle:event, const String:name[], bool:noBroadcast) {
    new target0 = GetClientOfUserId(GetEventInt(event, "userid"));
    new target1 = GetHealtarget(target0);
    CallAchievementEvent("medic_uber",target0, target1, 0, 0);
    ExpireBlocks(target1, 107);
    ExpireBlocks(target0, 108);
}

public GetHealtarget(client) {
    if(!IsValidClient(client) || TF2_GetPlayerClass(client) != TFClass_Medic)
        return 0;
    
    new weapon = GetPlayerWeaponSlot(client, 1);
    if (weapon == -1)
        return 0;
        
    new String:classname[64];
    GetEdictClassname(weapon, classname, 64);
    if(!StrEqual(classname, "tf_weapon_medigun"))
        return 0;
    
    return GetEntDataEnt2(weapon, FindSendPropInfo("CWeaponMedigun", "m_hHealingTarget"));
}

public Item_Found(Handle:event, const String:name[], bool:noBroadcast) {
    new target0 = GetEventInt(event, "player");
    CallAchievementEvent("item_found",target0, 0, 0, 0);
    GetEventString(event, "item", TempInputString, sizeof(TempInputString));
    Req_Crafted = GetEventBool(event, "crafted");
    ExpireBlocks(target0, 109);
    if (Req_Crafted) ExpireBlocks(target0, 111);
    else ExpireBlocks(target0, 110);
}

stock bool:TF2IsItemName(String:x[512], String:y[512]) {
    // WEAPONS
    if ((StrEqual(x, "kritzkrieg", false) || StrEqual(x, "kritz", false) || StrEqual(x, "the kritzkrieg", false)) && StrEqual(y, "TF_Unique_Achievement_Medigun1", false)) return true;
    if ((StrEqual(x, "blutsauger", false) || StrEqual(x, "blut", false) || StrEqual(x, "the blutsauger", false)) && StrEqual(y, "TF_Unique_Achievement_Syringegun1", false)) return true;
    if ((StrEqual(x, "ubersaw", false) || StrEqual(x, "uber", false) || StrEqual(x, "the ubersaw", false)) && StrEqual(y, "TF_Unique_Achievement_Bonesaw1", false)) return true;
    if ((StrEqual(x, "axtinguisher", false) || StrEqual(x, "axe", false) || StrEqual(x, "the axtinguisher", false)) && StrEqual(y, "TF_Unique_Achievement_FireAxe1", false)) return true;
    if ((StrEqual(x, "flaregun", false) || StrEqual(x, "flare", false) || StrEqual(x, "the flaregun", false)) && StrEqual(y, "TF_Unique_Achievement_FlareGun", false)) return true;
    if ((StrEqual(x, "backburner", false) || StrEqual(x, "back", false) || StrEqual(x, "the backburner", false)) && StrEqual(y, "TF_Unique_Achievement_Flamethrower", false)) return true;
    if ((StrEqual(x, "sandvich", false) || StrEqual(x, "sandwich", false) || StrEqual(x, "the sandvich", false) || StrEqual(x, "the sandwich", false)) && StrEqual(y, "TF_Unique_Achievement_LunchBox", false)) return true;
    if ((StrEqual(x, "natascha", false) || StrEqual(x, "natasha", false)) && StrEqual(y, "TF_Unique_Achievement_Minigun", false)) return true;
    if ((StrEqual(x, "sandman", false) || StrEqual(x, "ball", false) || StrEqual(x, "the sandman", false)) && StrEqual(y, "TF_Unique_Achievement_Bat", false)) return true;
    if ((StrEqual(x, "force-a-nature", false) || StrEqual(x, "fan", false) || StrEqual(x, "the force-a-nature", false) || StrEqual(x, "force a nature", false) || StrEqual(x, "the fan", false)) && StrEqual(y, "TF_Unique_Achievement_Scattergun_Double", false)) return true;
    if ((StrEqual(x, "bonk", false) || StrEqual(x, "bonk!", false) || StrEqual(x, "bonk! atomic punch", false) || StrEqual(x, "bonk! atomic punch!", false)) && StrEqual(y, "TF_Unique_Achievement_EnergyDrink", false)) return true;
    if ((StrEqual(x, "cloak and dagger", false) || StrEqual(x, "cloak", false) || StrEqual(x, "cnd", false) || StrEqual(x, "cloakanddagger", false)) && StrEqual(y, "TF_Unique_Achievement_CloakWatch", false)) return true;
    if ((StrEqual(x, "dead ringer", false) || StrEqual(x, "ringer", false) || StrEqual(x, "the dead ringer", false)) && StrEqual(y, "TF_Unique_Achievement_FeignWatch", false)) return true;
    if ((StrEqual(x, "ambassador", false) || StrEqual(x, "ambasador", false) || StrEqual(x, "the ambassador", false)) && StrEqual(y, "TF_Unique_Achievement_Revolver", false)) return true;
    if ((StrEqual(x, "razorback", false) || StrEqual(x, "shield", false) || StrEqual(x, "the razorback", false)) && StrEqual(y, "TF_Unique_Backstab_Shield", false)) return true;
    if ((StrEqual(x, "jarate", false) || StrEqual(x, "jar", false) || StrEqual(x, "piss", false)) && StrEqual(y, "TF_Unique_Achievement_Jar", false)) return true;
    if ((StrEqual(x, "huntsman", false) || StrEqual(x, "bow", false) || StrEqual(x, "the huntsman", false)) && StrEqual(y, "TF_Unique_Achievement_CompoundBow", false)) return true;
    if ((StrEqual(x, "buff banner", false) || StrEqual(x, "buffbanner", false) || StrEqual(x, "the buff banner", false)) && StrEqual(y, "TF_Unique_Achievement_SoldierBuff", false)) return true;
    if ((StrEqual(x, "equalizer", false) || StrEqual(x, "pickaxe", false) || StrEqual(x, "the equalizer", false)) && StrEqual(y, "TF_Unique_Achievement_Pickaxe", false)) return true;
    if ((StrEqual(x, "direct hit", false) || StrEqual(x, "directhit", false) || StrEqual(x, "the direct hit", false)) && StrEqual(y, "TF_Unique_Achievement_RocketLauncher", false)) return true;
    if ((StrEqual(x, "scottish resistance", false) || StrEqual(x, "scottishresistance", false) || StrEqual(x, "the scottish resistance", false)) && StrEqual(y, "TF_Unique_Achievement_StickyLauncher", false)) return true;
    if ((StrEqual(x, "chargin' targe", false) || StrEqual(x, "targe", false) || StrEqual(x, "the chargin' targe", false) || StrEqual(x, "charging targe", false)) && StrEqual(y, "TF_Unique_Achievement_Shield", false)) return true;
    if ((StrEqual(x, "gunboats", false) || StrEqual(x, "gun boats", false) || StrEqual(x, "the gunboats", false)) && StrEqual(y, "TF_Unique_Blast_Boots", false)) return true;
    if ((StrEqual(x, "homewrecker", false) || StrEqual(x, "home wrecker", false) || StrEqual(x, "the homewrecker", false)) && StrEqual(y, "TF_Unique_SledgeHammer", false)) return true;
    if ((StrEqual(x, "pain train", false) || StrEqual(x, "paintrain", false) || StrEqual(x, "the pain train", false)) && StrEqual(y, "TF_Unique_Makeshiftclub", false)) return true;
    if ((StrEqual(x, "Dalokohs Bar", false) || StrEqual(x, "Dalokohs", false) || StrEqual(x, "the Dalokohs Bar", false) || StrEqual(x, "chokolade", false)) && StrEqual(y, "TF_Unique_Lunchbox_Chocolate", false)) return true;
    if ((StrEqual(x, "lugermorph", false) || StrEqual(x, "max", false) || StrEqual(x, "the lugermorph", false) || StrEqual(x, "luger", false)) && StrEqual(y, "TF_TTG_MaxGun", false)) return true;
    if ((StrEqual(x, "big kill", false) || StrEqual(x, "sam", false) || StrEqual(x, "the big kill", false)) && StrEqual(y, "TF_TTG_SamRevolver", false)) return true;
    if ((StrEqual(x, "crit-a-cola", false) || StrEqual(x, "crit cola", false) || StrEqual(x, "critcola", false) || StrEqual(x, "crit a cola", false) || StrEqual(x, "critacola", false) || StrEqual(x, "the crit-a-cola", false)) && StrEqual(y, "TF_Unique_EnergyDrink_CritCola", false)) return true;
    if ((StrEqual(x, "Tribalman's Shiv", false) || StrEqual(x, "Tribalmans Shiv", false) || StrEqual(x, "Shiv", false) || StrEqual(x, "Tribalman Shiv", false) || StrEqual(x, "The Tribalman's Shiv", false)) && StrEqual(y, "TF_Unique_TribalmanKukri", false)) return true;
    if ((StrEqual(x, "Scotsman's Skullcutter", false) || StrEqual(x, "skullcutter", false) || StrEqual(x, "The Scotsman's Skullcutter", false) || StrEqual(x, "The Scotsmans Skullcutter", false) || StrEqual(x, "Scotsman Skullcutter", false)) && StrEqual(y, "TF_Unique_BattleAxe", false)) return true;
    
    // HATS
    if ((StrEqual(x, "Batter's Helmet", false) || StrEqual(x, "Batters Helmet", false) || StrEqual(x, "Scout Helmet", false)) && StrEqual(y, "TF_Unique_Headgear_Scout", false)) return true;
    if ((StrEqual(x, "Gentle Manne's Service Medal", false) || StrEqual(x, "Gentle Mannes Service Medal", false) || StrEqual(x, "Soldier Medal", false) || StrEqual(x, "Soldier's Medal", false) || StrEqual(x, "Soldiers Medal", false) || StrEqual(x, "medal", false)) && StrEqual(y, "TF_Soldier_Medal_Web_Sleuth", false)) return true;
    if ((StrEqual(x, "Grizzled Veteran", false) || StrEqual(x, "veteran", false) || StrEqual(x, "GrizzledVeteran", false) || StrEqual(x, "gold badge", false) || StrEqual(x, "gold", false) || StrEqual(x, "gold medal", false) || StrEqual(x, "badge a", false)) && StrEqual(y, "TF_Employee_Badge_A", false)) return true;
    if ((StrEqual(x, "Soldier of Fortune", false) || StrEqual(x, "fortune", false) || StrEqual(x, "SoldierofFortune", false) || StrEqual(x, "silver badge", false) || StrEqual(x, "silver", false) || StrEqual(x, "silver medal", false) || StrEqual(x, "badge b", false)) && StrEqual(y, "TF_Employee_Badge_B", false)) return true;
    if ((StrEqual(x, "Mercenary", false) || StrEqual(x, "bronze badge", false) || StrEqual(x, "bronze medal", false) || StrEqual(x, "bronze", false) || StrEqual(x, "badge c", false)) && StrEqual(y, "TF_Employee_Badge_C", false)) return true;
    if ((StrEqual(x, "Primeval Warrior", false) || StrEqual(x, "primeval", false) || StrEqual(x, "PrimevalWarrior", false) || StrEqual(x, "platinum badge", false) || StrEqual(x, "platinum", false) || StrEqual(x, "platinum medal", false) || StrEqual(x, "badge plat", false)) && StrEqual(y, "TF_Employee_Badge_Plat", false)) return true;
    
    // MISC ITEM
    if ((StrEqual(x, "scrap metal", false) || StrEqual(x, "metal", false) || StrEqual(x, "scrap", false)) && StrEqual(y, "CI_Bar_A", false)) return true;
    if ((StrEqual(x, "Reclaimed Metal", false) || StrEqual(x, "metal", false) || StrEqual(x, "reclaimed", false)) && StrEqual(y, "CI_Bar_B", false)) return true;
    if ((StrEqual(x, "Refined Metal", false) || StrEqual(x, "metal", false) || StrEqual(x, "refined", false)) && StrEqual(y, "CI_Bar_C", false)) return true;
    
    return false;
}